<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Larry Adams                                          |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

include("./include/auth.php");
include_once("./include/config_arrays.php");

define("MAX_DISPLAY_PAGES", 21);

include_once("./include/top_mactrack_header.php");

mactrack_view();

include_once("./include/bottom_footer.php");

function mactrack_view() {
        global $colors, $device_actions, $mac_track_search_types, $mac_track_device_types;

        /* ================= input validation ================= */
        input_validate_input_number(get_request_var_request("site_id"));
        input_validate_input_number(get_request_var_request("device_id"));
        input_validate_input_number(get_request_var_request("rowstoshow"));
        input_validate_input_number(get_request_var_request("mac_filter_type_id"));
        input_validate_input_number(get_request_var_request("ip_filter_type_id"));
        input_validate_input_number(get_request_var_request("page"));
        /* ==================================================== */

        /* clean up search string */
        if (isset($_REQUEST["mac_filter"])) {
                $_REQUEST["mac_filter"] = sanitize_search_string(get_request_var("mac_filter"));
        }

        /* clean up search string */
        if (isset($_REQUEST["ip_filter"])) {
                $_REQUEST["ip_filter"] = sanitize_search_string(get_request_var("ip_filter"));
        }

        /* if the user pushed the 'clear' button */
        if (isset($_REQUEST["clear_x"])) {
                kill_session_var("sess_mactrack_view_current_page");
                kill_session_var("sess_mactrack_view_rowstoshow");
                kill_session_var("sess_mactrack_view_mac_filter_type_id");
                kill_session_var("sess_mactrack_view_mac_filter");
                kill_session_var("sess_mactrack_view_ip_filter_type_id");
                kill_session_var("sess_mactrack_view_ip_filter");
                kill_session_var("sess_mactrack_view_site_id");
                kill_session_var("sess_mactrack_view_device_id");

                unset($_REQUEST["page"]);
                unset($_REQUEST["rowstoshow"]);
                unset($_REQUEST["mac_filter_type_id"]);
                unset($_REQUEST["mac_filter"]);
                unset($_REQUEST["ip_filter_type_id"]);
                unset($_REQUEST["ip_filter"]);
                unset($_REQUEST["site_id"]);
                unset($_REQUEST["device_id"]);
        }

        /* reset some things if the user has made changes */
        if ((!empty($_REQUEST["site_id"]))&&(!empty($_SESSION["sess_mactrack_view_site_id"]))) {
                if ($_REQUEST["site_id"] <> $_SESSION["sess_mactrack_view_site_id"]) {
                        $_REQUEST["device_id"] = "-1";
                }
        }

        /* remember these search fields in session vars so we don't have to keep passing them around */
        load_current_session_value("page", "sess_mactrack_view_current_page", "1");
        load_current_session_value("rowstoshow", "sess_mactrack_view_rowstoshow", "2");
        load_current_session_value("mac_filter_type_id", "sess_mactrack_view_mac_filter_type_id", "1");
        load_current_session_value("mac_filter", "sess_mactrack_view_mac_filter", "");
        load_current_session_value("ip_filter_type_id", "sess_mactrack_view_ip_filter_type_id", "1");
        load_current_session_value("ip_filter", "sess_mactrack_view_ip_filter", "");
        load_current_session_value("site_id", "sess_mactrack_view_site_id", "-1");
        load_current_session_value("device_id", "sess_mactrack_view_device_id", "-1");

        html_start_box("<strong>Mac Track Results Filtering</strong>", "98%", $colors["header"], "3", "center", "");

        include("./include/html/inc_mactrack_view_filter_table.php");

        html_end_box();

        /* form the 'where' clause for our main sql query */
        $sql_where = "";
        if (strlen($_REQUEST["mac_filter"]) > 0) {
                if (strlen($sql_where) > 0) {
                        $sql_where .= " AND ";
                }else{
                        $sql_where .= " WHERE ";
                }
                switch ($_REQUEST["mac_filter_type_id"]) {
                case "1": /* matches */
                        $sql_where .= " mac_track_ports.mac_address='" . $_REQUEST["mac_filter"] . "'";
                        break;
                case "2": /* contains */
                        $sql_where .= " mac_track_ports.mac_address like '%%" . $_REQUEST["mac_filter"] . "%%'";
                        break;
                case "3": /* begins with */
                        $sql_where .= " mac_track_ports.mac_address like '" . $_REQUEST["mac_filter"] . "%%'";
                        break;
                case "4": /* does not contain */
                        $sql_where .= " mac_track_ports.mac_address NOT LIKE '" . $_REQUEST["mac_filter"] . "%%'";
                        break;
                case "5": /* does not begin with */
                        $sql_where .= " mac_track_ports.mac_address NOT LIKE '" . $_REQUEST["mac_filter"] . "%%'";
                }
        }

        if ((strlen($_REQUEST["ip_filter"]) > 0)||($_REQUEST["ip_filter_type_id"] > 5)) {
                if (strlen($sql_where) > 0) {
                        $sql_where .= " AND ";
                }else{
                        $sql_where .= " WHERE ";
                }
                switch ($_REQUEST["ip_filter_type_id"]) {
                case "1": /* matches */
                        $sql_where .= " mac_track_ports.ip_address='" . $_REQUEST["ip_filter"] . "'";
                        break;
                case "2": /* contains */
                        $sql_where .= " mac_track_ports.ip_address like '%%" . $_REQUEST["ip_filter"] . "%%'";
                        break;
                case "3": /* begins with */
                        $sql_where .= " mac_track_ports.ip_address like '" . $_REQUEST["ip_filter"] . "%%'";
                        break;
                case "4": /* does not contain */
                        $sql_where .= " mac_track_ports.ip_address NOT LIKE '" . $_REQUEST["ip_filter"] . "%%'";
                        break;
                case "5": /* does not begin with */
                        $sql_where .= " mac_track_ports.ip_address NOT LIKE '" . $_REQUEST["ip_filter"] . "%%'";
                        break;
                case "6": /* is null */
                        $sql_where .= " mac_track_ports.ip_address = ''";
                        break;
                case "7": /* is not null */
                        $sql_where .= " mac_track_ports.ip_address != ''";
                }
        }

        if (!($_REQUEST["site_id"] == "-1")) {
                if (strlen($sql_where) > 0) {
                        $sql_where .= " AND ";
                }else{
                        $sql_where .= " WHERE ";
                }
                $sql_where .= " mac_track_ports.site_id=" . $_REQUEST["site_id"];
        }

        if (!($_REQUEST["device_id"] == "-1")) {
                if (strlen($sql_where) > 0) {
                        $sql_where .= " AND ";
                }else{
                        $sql_where .= " WHERE ";
                }
                $sql_where .= " mac_track_ports.device_id=" . $_REQUEST["device_id"];
        }

        html_start_box("", "98%", $colors["header"], "3", "center", "");

        if ($_REQUEST["rowstoshow"] == 1) {
                $rows_query_string = "SELECT
                        COUNT(mac_track_ports.device_id)
                        FROM mac_track_ports
                        $sql_where";

                $query_string = "SELECT *
                        FROM mac_track_ports
                        $sql_where
                        ORDER BY mac_track_ports.hostname, mac_track_ports.port_number, mac_track_ports.ip_address
                        LIMIT " . (read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_mactrack");

                if (strlen($sql_where) == 0) {
                                $total_rows = 0;
                }else{
                        $total_rows = db_fetch_cell($rows_query_string);
                }
        }else{
                $rows_query_string = "SELECT
                        COUNT(DISTINCT device_id, mac_address, port_number, ip_address)
                        FROM mac_track_ports
                        $sql_where";

                $query_string = "SELECT
                        description, hostname, mac_address, ip_address, port_number,
                        port_name, vlan_id, vlan_name, MAX(scan_date) as max_scan_date
                        FROM mac_track_ports
                        $sql_where
                        GROUP BY device_id, mac_address, port_number, ip_address
                        ORDER BY mac_track_ports.hostname, mac_track_ports.port_number, mac_track_ports.ip_address
                        LIMIT " . (read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1)) . "," . read_config_option("num_rows_mactrack");

                if (strlen($sql_where) == 0) {
                        $total_rows = 0;
                }else{
                        $total_rows = db_fetch_cell($rows_query_string);
                }
        }

        if (strlen($sql_where) == 0) {
                $port_results = array();
        }else{
                $port_results = db_fetch_assoc($query_string);
        }

        /* generate page list */
        $url_page_select = get_page_list($_REQUEST["page"], MAX_DISPLAY_PAGES, read_config_option("num_rows_mactrack"), $total_rows, "mactrack_view.php?device_id=" . $_REQUEST["device_id"] . "&ip_filter_type_id=" . $_REQUEST["ip_filter_type_id"] . "&ip_filter=" . $_REQUEST["ip_filter"] . "&mac_filter_type_id=" . $_REQUEST["mac_filter_type_id"] . "&mac_filter=" . $_REQUEST["mac_filter"] . "&site_id=" . $_REQUEST["site_id"]);

        $nav = "<tr bgcolor='#" . $colors["header"] . "'>
                        <td colspan='9'>
                                <table width='100%' cellspacing='0' cellpadding='0' border='0'>
                                        <tr>
                                                <td align='left' class='textHeaderDark'>
                                                        <strong>&lt;&lt; "; if ($_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='mactrack_view.php?device_id=" . $_REQUEST["device_id"] . "&ip_filter_type_id=" . $_REQUEST["ip_filter_type_id"] . "&ip_filter=" . $_REQUEST["ip_filter"] . "&mac_filter_type_id=" . $_REQUEST["mac_filter_type_id"] . "&mac_filter=" . $_REQUEST["mac_filter"] . "&site_id=" . $_REQUEST["site_id"] . "&page=" . ($_REQUEST["page"]-1) . "'>"; } $nav .= "Previous"; if ($_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
                                                </td>\n
                                                <td align='center' class='textHeaderDark'>
                                                        Showing Rows " . ((read_config_option("num_rows_mactrack")*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < read_config_option("num_rows_mactrack")) || ($total_rows < (read_config_option("num_rows_mactrack")*$_REQUEST["page"]))) ? $total_rows : (read_config_option("num_rows_mactrack")*$_REQUEST["page"])) . " of $total_rows [$url_page_select]
                                                </td>\n
                                                <td align='right' class='textHeaderDark'>
                                                        <strong>"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "<a class='linkOverDark' href='mactrack_view.php?device_id=" . $_REQUEST["device_id"] . "&ip_filter_type_id=" . $_REQUEST["ip_filter_type_id"] . "&ip_filter=" . $_REQUEST["ip_filter"] . "&mac_filter_type_id=" . $_REQUEST["mac_filter_type_id"] . "&mac_filter=" . $_REQUEST["mac_filter"] . "&site_id=" . $_REQUEST["site_id"] . "&page=" . ($_REQUEST["page"]+1) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * read_config_option("num_rows_mactrack")) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
                                                </td>\n
                                        </tr>
                                </table>
                        </td>
                </tr>\n";

        print $nav;

        html_header(array("Network<br>Device", "Network<br>Hostname", "End Device<br>MAC Address", "End Device<br>IP Address", "Port<br>Number", "Port<br>Name", "VLAN<br>ID", "VLAN<br>Name", "Last<br>Scan Date"));

        $i = 0;
        if (sizeof($port_results) > 0) {
                foreach ($port_results as $port_result) {
                        if ($_REQUEST["rowstoshow"] == 1) {
                                $scan_date = $port_result["scan_date"];
                        }else{
                                $scan_date = $port_result["max_scan_date"];
                        }

                        form_alternate_row_color($colors["alternate"],$colors["light"],$i); $i++;
                                ?>
                                <td><?php print ($port_result["description"]);?></td>
                                <td><?php print ($port_result["hostname"]);?></td>
                                <td><?php print eregi_replace("(" . preg_quote($_REQUEST["mac_filter"]) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $port_result["mac_address"]);?></td>
                                <td><?php print eregi_replace("(" . preg_quote($_REQUEST["ip_filter"]) . ")", "<span style='background-color: #F8D93D;'>\\1</span>", $port_result["ip_address"]);?></td>
                                <td><?php print ($port_result["port_number"]);?></td>
                                <td><?php print ($port_result["port_name"]);?></td>
                                <td><?php print ($port_result["vlan_id"]);?></td>
                                <td><?php print ($port_result["vlan_name"]);?></td>
                                <td><?php print ($scan_date);?></td>
                        </tr>
                        <?php
                }

                /* put the nav bar on the bottom as well */
                print $nav;
        }else{
                print "<tr><td><em>No Mac Track Port Results</em></td></tr>";
        }
        html_end_box(false);
}

?>